package org.jeecg.modules.oroqen.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.oroqen.entity.OroqenHeritageInheritor;
import org.jeecg.modules.oroqen.service.IOroqenHeritageInheritorService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;

/**
 * @Description: 非遗传承人
 * @Author: jeecg-boot
 * @Date: 2025-01-08
 * @Version: V1.0
 */
@Tag(name = "非遗传承人", description = "非遗传承人")
@RestController
@RequestMapping("/oroqen/heritageInheritor")
@Slf4j
public class OroqenHeritageInheritorController extends JeecgController<OroqenHeritageInheritor, IOroqenHeritageInheritorService> {

    @Autowired
    private IOroqenHeritageInheritorService oroqenHeritageInheritorService;

    /**
     * 分页列表查询
     */
    @AutoLog(value = "非遗传承人-分页列表查询")
    @Operation(summary = "非遗传承人-分页列表查询", description = "非遗传承人-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<OroqenHeritageInheritor>> queryPageList(OroqenHeritageInheritor oroqenHeritageInheritor,
                                                                @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                                @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                                HttpServletRequest req) {
        QueryWrapper<OroqenHeritageInheritor> queryWrapper = QueryGenerator.initQueryWrapper(oroqenHeritageInheritor, req.getParameterMap());
        Page<OroqenHeritageInheritor> page = new Page<OroqenHeritageInheritor>(pageNo, pageSize);
        IPage<OroqenHeritageInheritor> pageList = oroqenHeritageInheritorService.page(page, queryWrapper);
        return Result.OK(pageList);
    }

    /**
     * 添加
     */
    @AutoLog(value = "非遗传承人-添加")
    @Operation(summary = "非遗传承人-添加", description = "非遗传承人-添加")
    @PostMapping(value = "/add")
    public Result<String> add(@RequestBody OroqenHeritageInheritor oroqenHeritageInheritor) {
        oroqenHeritageInheritorService.save(oroqenHeritageInheritor);
        return Result.OK("添加成功！");
    }

    /**
     * 编辑
     */
    @AutoLog(value = "非遗传承人-编辑")
    @Operation(summary = "非遗传承人-编辑", description = "非遗传承人-编辑")
    @RequestMapping(value = "/edit", method = {RequestMethod.PUT, RequestMethod.POST})
    public Result<String> edit(@RequestBody OroqenHeritageInheritor oroqenHeritageInheritor) {
        oroqenHeritageInheritorService.updateById(oroqenHeritageInheritor);
        return Result.OK("编辑成功!");
    }

    /**
     * 通过id删除
     */
    @AutoLog(value = "非遗传承人-通过id删除")
    @Operation(summary = "非遗传承人-通过id删除", description = "非遗传承人-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
        oroqenHeritageInheritorService.removeById(id);
        return Result.OK("删除成功!");
    }

    /**
     * 批量删除
     */
    @AutoLog(value = "非遗传承人-批量删除")
    @Operation(summary = "非遗传承人-批量删除", description = "非遗传承人-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        this.oroqenHeritageInheritorService.removeByIds(Arrays.asList(ids.split(",")));
        return Result.OK("批量删除成功!");
    }

    /**
     * 通过id查询
     */
    @AutoLog(value = "非遗传承人-通过id查询")
    @Operation(summary = "非遗传承人-通过id查询", description = "非遗传承人-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<OroqenHeritageInheritor> queryById(@RequestParam(name = "id", required = true) String id) {
        OroqenHeritageInheritor oroqenHeritageInheritor = oroqenHeritageInheritorService.getById(id);
        if (oroqenHeritageInheritor == null) {
            return Result.error("未找到对应数据");
        }
        return Result.OK(oroqenHeritageInheritor);
    }

    /**
     * 导出excel
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, OroqenHeritageInheritor oroqenHeritageInheritor) {
        return super.exportXls(request, oroqenHeritageInheritor, OroqenHeritageInheritor.class, "非遗传承人");
    }

    /**
     * 通过excel导入数据
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, OroqenHeritageInheritor.class);
    }
}